#!/bin/bash

function error {
    echo !!! ERROR HAS OCCURED. EXITING. !!!
    exit 1
}

function quit {
    exit 0
}

PATCHFILE=patch.messageid.in.context.menu.diff
JARFILE='../chrome/messenger.jar'
FILES2EXTRACT='content/messenger/mailWindowOverlay.xul content/messenger/nsContextMenu.js' 

function do_patch {
    echo == Extracting...
    unzip -o "$JARFILE" $FILES2EXTRACT || error
    echo == Patching...
    patch $1 -f -p 0 < "diff/$PATCHFILE" || error
    echo == Adding to archive...
    zip "$JARFILE" $FILES2EXTRACT || error
}

function do_revert {
    echo == Reverting...
    do_patch -R
}

function do_cleanup {
    echo == Cleanup...
    rm -r content
}

echo =================================
echo Patching script for Thunderbird 3
echo Inline Message-Id click ability
echo =================================

case "$1" in
    'clean')
        do_cleanup
        ;;
    'revert')
        do_cleanup
        do_revert
        ;;
    *)
        do_cleanup
        do_patch
        ;;
esac

echo == Finished.
